﻿using Infragistics.UltraGauge.Resources;
using Infragistics.Win.UltraWinGauge;
using System;
using System.Windows.Forms;
using System.Drawing;


public class Form1 : Form
{

private UltraGauge ultraGauge1;
public Form1()
{
    this.ultraGauge1 = new UltraGauge();
    this.ultraGauge1.Dock = DockStyle.Fill;
    this.Controls.Add(this.ultraGauge1);

    LinearGauge lin = new LinearGauge();
    LinearGaugeScale linearScale = new LinearGaugeScale();

    linearScale.StartExtent = 10.0;
    linearScale.EndExtent = 90.0;
    linearScale.Labels.BrushElement = new SolidFillBrushElement(Color.Black);
    linearScale.MajorTickmarks.StrokeElement.Color = Color.Black;

    NumericAxis axis = new NumericAxis();

    axis.StartValue = 0.0;
    axis.EndValue = 10.0;
    axis.TickmarkInterval = 1.0;

    LinearGaugeNeedle needle = new LinearGaugeNeedle();

    needle.BrushElement = new SolidFillBrushElement(Color.Black);
    needle.Value = 3.14;

    this.ultraGauge1.Gauges.Add(lin);
    lin.Scales.Add(linearScale);
    linearScale.Axis = axis;
    linearScale.Markers.Add(needle);

    this.ultraGauge1.PrimitiveMouseDown += new GaugePrimitiveMouseEventHandler(this.ultraGauge1_PrimitiveMouseDown);
    this.ultraGauge1.MouseMove += new MouseEventHandler(this.ultraGauge1_MouseMove);
    this.ultraGauge1.MouseLeave += new EventHandler(this.ultraGauge1_MouseLeave);
    this.ultraGauge1.MouseUp += new MouseEventHandler(this.ultraGauge1_MouseUp);
}

private LinearGaugeNeedle DraggingNeedle { get; set; }

private void ultraGauge1_PrimitiveMouseDown(object sender, GaugePrimitiveMouseEventArgs e)
{
    LinearGaugeNeedle needle = e.Primitive.Element as LinearGaugeNeedle;
    if (needle != null)
    {
        this.DraggingNeedle = needle;
    }
}

private void ultraGauge1_MouseMove(object sender, MouseEventArgs e)
{
    if (this.DraggingNeedle != null)
    {
        Rectangle scaleBounds = this.DraggingNeedle.Scale.GetScaleBounds(this.ultraGauge1.Bounds);

        this.DraggingNeedle.Value =
            this.DraggingNeedle.Scale.Axis.MapInverse(e.X, scaleBounds.Left, scaleBounds.Right);
    }
}

protected override void OnMouseUp(MouseEventArgs e)
{
    base.OnMouseUp(e);
    this.DraggingNeedle = null;
}

protected override void OnMouseLeave(EventArgs e)
{
    base.OnMouseLeave(e);
    this.DraggingNeedle = null;
}

private void ultraGauge1_MouseLeave(object sender, EventArgs e)
{
    this.DraggingNeedle = null;
}
private void ultraGauge1_MouseUp(object sender, MouseEventArgs e)
{
    this.DraggingNeedle = null;
}

}
